﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;

namespace XamDataChartColumnSeriesBinderCase
{
    public class SeriesBinder
        : DependencyObject
    {
        public static DependencyProperty ContextBridgeProperty =
          DependencyProperty.RegisterAttached("ContextBridge",
          typeof(object), typeof(SeriesBinder),
          new PropertyMetadata(null,
              (o, e) =>
              {
                  SeriesBindingInfo sbi = GetBindingInfo(o);
                  if (sbi != null)
                  {
                      sbi.OuterContext = e.NewValue;
                  }
              }));

        public static DependencyProperty BindingInfoProperty =
            DependencyProperty.RegisterAttached("BindingInfo",
            typeof(SeriesBindingInfo), typeof(SeriesBinder),
            new PropertyMetadata(null,
                (o, e) =>
                {
                    if (o is XamDataChart)
                    {
                        SeriesBindingInfo prev = GetBindingInfo(o);
                        if (prev != null && prev.Owner != null)
                        {
                            prev.Owner = null;
                        }
                        if (e.NewValue != null)
                        {
                            XamDataChart newOwner =
                                o as XamDataChart;
                            newOwner.SetBinding(
                                SeriesBinder.ContextBridgeProperty,
                                new Binding());

                            (e.NewValue as SeriesBindingInfo)
                                .Owner = (XamDataChart)o;

                            if (GetContextBridge(o) != null)
                            {
                                (e.NewValue as SeriesBindingInfo)
                                    .OuterContext = GetContextBridge(o);
                            }
                        }
                    }
                }));


        public static void SetBindingInfo(
            DependencyObject target,
            SeriesBindingInfo info)
        {
            target.SetValue(BindingInfoProperty, info);
        }

        public static SeriesBindingInfo GetBindingInfo(
            DependencyObject target)
        {
            return (SeriesBindingInfo)target.GetValue(BindingInfoProperty);
        }

        public static void SetContextBridge(
            DependencyObject target,
            object context)
        {
            target.SetValue(ContextBridgeProperty, context);
        }

        public static object GetContextBridge(
            DependencyObject target)
        {
            return target.GetValue(ContextBridgeProperty);
        }
    }
}
